﻿@page "/counter"

@namespace ServiceDesk.Presentation.Components.Mantenimientos

@using System.Collections.ObjectModel
@using System.Collections;
@using Microsoft.AspNetCore.Components.Authorization
@inject PrioridadAgent prioridadAgent 
@inject IncidenteAgent incidenteAgent
@inject DepartamentoAgent departamentoAgent
@inject UsuarioAgent usuarioAgent

<TelerikGrid Data=@GridData EditMode="@GridEditMode.Popup"
             Pageable="true" PageSize=25
             OnUpdate=@UpdateItem OnDelete=@DeleteItem>
    <GridToolBar>
        <GridCommandButton OnClick="OpenAddModal" Icon="add">Agregar Incidente</GridCommandButton>
    </GridToolBar>
    <GridColumns>
        <GridColumn Field=@nameof(IncidenteDto.Titulo) />
        <GridColumn Field=@nameof(IncidenteDto.DepartamentoId) />
        <GridColumn Field=@nameof(IncidenteDto.CreadoPor) Title="Creado Por" />
        <GridColumn Field=@nameof(IncidenteDto.FechaRegistro) DisplayFormat="{0:dd/MM/yyyy hh:mm tt}" Title="Fecha de Registro" />
        <GridCommandColumn Width="120px">
            <GridCommandButton Command="Delete" Icon="delete"></GridCommandButton>
        </GridCommandColumn>
    </GridColumns>
</TelerikGrid>

<!--Modal para agregar un nuevo incidente.-->

<TelerikWindow Class="demo-window" Centered="true" @bind-Visible=@WindowVisible Modal="true">
    <WindowTitle>
        <strong>Solicitud de Incidente</strong>
    </WindowTitle>
    <WindowActions>
        <WindowAction Name="Close" />
    </WindowActions>
    <WindowContent>
        <TelerikForm Model="@incidente"
                     Width="700px"
                     Columns="2"
                     ColumnSpacing="20px"
                     OnValidSubmit="@CreateItem">
            <FormValidation>
                <DataAnnotationsValidator></DataAnnotationsValidator>
            </FormValidation>
            <FormItems>
                <FormGroup LabelText="Información general">
                    <FormItem Field="@nameof(IncidenteDto.Titulo)" />
                    <FormItem Field="@nameof(IncidenteDto.Descripcion)">
                        <Template>
                            <label class="k-label k-form-label">Descripcion:</label>
                            <TelerikTextArea @bind-Value="incidente.Descripcion"></TelerikTextArea>
                        </Template>
                    </FormItem>

                    <FormItem Field="@nameof(IncidenteDto.PrioridadId)">
                        <Template>
                            <label class="k-label k-form-label">Prioridad:</label>
                            <TelerikComboBox Data="@prioridades" Placeholder="Selecciona la prioridad" @bind-Value="@incidente.PrioridadId"
                                             TextField="@nameof(PrioridadDto.Nombre)" ValueField="@nameof(PrioridadDto.Id)" Filterable="true" Width="100%">
                            </TelerikComboBox>
                        </Template>
                    </FormItem>

                </FormGroup>
                <FormGroup LabelText="Asignación de la solicitud">
                    <FormItem Field="@nameof(IncidenteDto.DepartamentoId)">
                        <Template>
                            <label class="k-label k-form-label">Departamento:</label>
                            <TelerikComboBox Data="@departamentos" Placeholder="Selecciona el Departamento" @bind-Value="@incidente.DepartamentoId"
                                             TextField="@nameof(DepartamentoDto.Nombre)" ValueField="@nameof(DepartamentoDto.Id)" Filterable="true" Width="100%">
                            </TelerikComboBox>
                        </Template>
                    </FormItem>

                    <FormItem Field="@nameof(IncidenteDto.UsuarioAsignadoId)">
                        <Template>
                            <label class="k-label k-form-label">Asignado a:</label>
                            <TelerikComboBox Data="@usuarios" Placeholder="Selecciona el usuario" @bind-Value="@incidente.UsuarioAsignadoId"
                                             TextField="@nameof(UsuarioDto.Nombre)" ValueField="@nameof(UsuarioDto.Id)" Filterable="true" Width="100%">
                            </TelerikComboBox>
                        </Template>
                    </FormItem>
                </FormGroup>
            </FormItems>
        </TelerikForm>
    </WindowContent>
</TelerikWindow>

<!--Modal para visualizar un incidente ya creado -->
<TelerikWindow Class="demo-window" Centered="true" Modal="true">
    <WindowTitle>
        <strong>Incidente</strong>
    </WindowTitle>
    <WindowActions>
        <WindowAction Name="Close" />
    </WindowActions>
    <WindowContent>
        
    </WindowContent>
</TelerikWindow>

<TelerikWindow Class="demo-window" Width="500px" Height="300px" Centered="true" @bind-Visible=@WindowVisible Modal="true">
    <WindowTitle>
        <strong>Modal Window</strong>
    </WindowTitle>
    <WindowActions>
        <WindowAction Name="Close" />
    </WindowActions>
    <WindowContent>
        <p>Click the close button to dismiss this modal dialog.</p>
    </WindowContent>
</TelerikWindow>

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationState { get; set; }

    [CascadingParameter]
    private DialogFactory Dialog { get; set; }

    public IncidenteDto incidente { get; set; } = new IncidenteDto();

    public bool WindowVisible { get; set; }

    public List<IncidenteDto> GridData { get; set; } = new List<IncidenteDto>();

    public List<DepartamentoDto> departamentos { get; set; } = new List<DepartamentoDto>();

    public List<PrioridadDto> prioridades { get; set; } = new List<PrioridadDto>();

    public List<UsuarioDto> usuarios { get; set; } = new List<UsuarioDto>();

    protected override async Task OnInitializedAsync()
    {
        try
        {
            Timer timer = new Timer();
            timer.Interval = 5000;
            timer.Elapsed += timer_elapsed;
            await LoadData();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }

    private async void timer_elapsed(object sender, ElapsedEventArgs e)
    {
        await LoadData();
    }

    private async Task LoadData()
    {
        try
        {
            usuarios = await usuarioAgent.Get();
            prioridades = await prioridadAgent.Get();
            GridData = await incidenteAgent.Get();
            departamentos = await departamentoAgent.Get();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

        StateHasChanged();
    }

    private async void OpenAddModal()
    {
        WindowVisible = true;

    }

    private async void CreateItem()
    {
        try
        {
            incidente.UsuarioReportaId = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            incidente.CreadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            incidente.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            incidente.ComentarioCierre = "";
            await incidenteAgent.Add(incidente);
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }
    }

    private async void DeleteItem(GridCommandEventArgs args)
    {
        //DepartamentoDto depto = args.Item as DepartamentoDto;
        //try
        //{
        //    if (await Dialog.ConfirmAsync("¿Está seguro que desea borrar este registro?"))
        //    {

        //    }
        //    await departamentoAgent.Remove(depto.Id);
        //}
        //catch (Exception ex)
        //{
        //    Console.WriteLine(ex.Message);
        //    throw;
        //}
        //StateHasChanged();
    }

    private async void UpdateItem(GridCommandEventArgs args)
    {
        //try
        //{
        //    DepartamentoDto depto = args.Item as DepartamentoDto;
        //    depto.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
        //    await departamentoAgent.Edit(depto);
        //    StateHasChanged();
        //}
        //catch (Exception ex)
        //{
        //    Console.WriteLine(ex.Message);
        //    throw;
        //}

    }
}